/***********************************************
*  FreeRTOS Test Program sample7
*  GateKeeper Task Control
***********************************************/
#include <p24FJ128GA010.h>
#include "FreeRTOS.h"					/* FreeRTOSwb_ */
#include "task.h"
#include "semphr.h"
/***  RtBM[Vݒ  ***/
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx2) 
// 8MHz*PLL4=32MHz (Full Speed)
_CONFIG2(IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_OFF & POSCMOD_HS & FNOSC_PRIPLL)

/* 萔ϐ`*/
#define SYS_FREQ	32000000
static char StMsg[] = "\r\n*** FreeRTOS Test Program No7 ***\r\n";
xQueueHandle UARTQueue;

/* ֐vg */
void vTask1( void *pvParameters );			// ^XN1
void vTask2( void *pvParameters );			// ^XN2
void vTask3( void *pvParameters );			// ^XN3
void itostring(char digit, unsigned int data, char *buffer);
void OutStr(char *buffer);

/****************** C֐ ************************/
int main(void){
	volatile unsigned long ul;
		
	/* VXeݒ */
	LATA = 0; 							// LEDݒ
	TRISA = 0;

	/// UART2ݒ@9600bps 8rbg peBȂAt[Ȃ
	U2BRG = 103;							// 9600bps@FCY=16MHz
	U2MODE = 0b1000000000000000;			// UART2ݒ	
	U2STA =  0b0000010000000000;			// UART2ݒ	
	for(ul=0; ul<10000; ul++){};			// UART҂
	OutStr(StMsg);
	/* L[obt@@*/
	UARTQueue = xQueueCreate(5, 22);		// 22Byte x 5
	if(UARTQueue != NULL){
		/* ^XN  */
		xTaskCreate( vTask1, (signed portCHAR *)"T1", 200, NULL, 1, NULL );
		xTaskCreate( vTask2, (signed portCHAR *)"T2", 200, NULL, 1, NULL );		
		xTaskCreate( vTask3, (signed portCHAR *)"T3", 200, NULL, 1, NULL );
		/* XPW[OJn@*/
		vTaskStartScheduler();
	}
	/********@C[v  *******/
	while(1)
	{	}
}

/***** ^XN1֐ ******/
void vTask1(void *pvParameters){
	static char Msg1[] = "Task1 Count = xxxxx\r\n";
	static unsigned int Count1 = 0;

	while(1)	{	// 0.4bŌJԂ
		LATA ^= 0x80;							// LED_
		itostring(5, Count1, Msg1+14);			// bZ[Wp
		xQueueSendToBack(UARTQueue, Msg1, portMAX_DELAY);
		Count1++;
		vTaskDelay( 400 / portTICK_RATE_MS );
	}
}
/***** ^XN2֐ ******/
void vTask2(void *pvParameters){
	static char Msg2[] = "Task2 Count = xxxxx\r\n";
	static unsigned int Count2 = 0;

	while(1)	{	// 0.2bŌJԂ
		LATA ^= 0x40;							// LED_
		itostring(5, Count2, Msg2+14);			// bZ[Wp
		xQueueSendToBack(UARTQueue, Msg2, portMAX_DELAY);
		Count2++;
		vTaskDelay( 200 / portTICK_RATE_MS );
	}
}
/***** ^XN3֐ ******/
void vTask3(void *pvParameters){
	char Buf[32];

	while(1) {
		LATA ^= 0x20;							// LED_
		/* L[f[^o */
		xQueueReceive(UARTQueue, Buf, portMAX_DELAY);
		OutStr(Buf);
	}
}
/*****************************************
*   l當ɕϊ
*****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;

	buffer += digit;						//̍Ō
	for(i=digit; i>0; i--) {				//ŉʌʂ
		buffer--;						//|C^[P
		*buffer = (data % 10) + '0';		//̌l𕶎ɂĊi[
		data = data / 10;					//-1
	}
}
/*****************************************
*   UART2ɕo
*****************************************/
void OutStr(char *buffer){
	while(*buffer != 0){
		while(!U2STAbits.TRMT);		
		U2TXREG = *buffer;
		buffer++;
	}
}
